<template>
  <div class="simplePushAndUpload">
    <div
      class="dragAndDropArea"
      :class="{ shake: shake, success: showSuccess }"
      @dragenter="dragenter"
      @dragleave="dragleave"
      @dragover="dragover"
      @drop="drop"
    >
      <div class="centered">
        <span v-if="!showSuccess" style="pointer-events: none">
          Push file here to Upload
        </span>
        <img
          v-if="showSuccess"
          src="../assets/thumbs_up.svg"
          alt="thumbs up"
          height="100"
        >
      </div>
    </div>
    <Progress
      class="centered"
      v-if="uploadInProgress"
      v-bind:percent="percent"
      bgColor="lightslategray"
      fgColor="deepskyblue"
    ></Progress>
    <div v-if="filenames.length">
      Uploaded files
      <ul>
        <li v-for="filename in filenames" v-bind:key="filename">
          {{ filename }}
        </li>
      </ul>
    </div>
  </div>
</template>

<script lang="ts">
import { Options, Vue } from "vue-class-component";
import Progress from "@/components/Progress.vue";

@Options({
  components: {
    Progress,
  },
})
export default class SimplePushAndUpload extends Vue {
  public uploadInProgress = false;
  public shake = false;
  public showSuccess = false;
  public filenames = [];

  private percent = 0;
  private timerProgress!: number | null;

  dragleave(): void {
    if (this.uploadInProgress) {
      this.abortUpload();
    }
  }

  drop(e: DragEvent): void {
    if (this.uploadInProgress) {
      this.abortUpload();
    } else {
      this.completeUpload(e);
    }
    e.preventDefault();
  }

  private completeUpload(ev: DragEvent) {
    const fileNames = this.getFileNames(ev);
    if (fileNames && fileNames.length) {
      this.success();
      Array.prototype.push.apply(this.filenames, fileNames);
    } else {
      this.error();
    }
  }
  private success() {
    this.showSuccess = true;
    setTimeout(() => {
      this.showSuccess = false;
    }, 1000);
  }

  private getFileNames(ev: DragEvent): string[] {
    const fileNames = [];
    if (ev.dataTransfer) {
      if (ev.dataTransfer.items) {
        // Use DataTransferItemList interface to access the file(s)
        for (const item of ev.dataTransfer.items) {
          // If dropped items aren't files, reject them
          if (item.kind === "file") {
            const file = item.getAsFile();
            if (file && file.name) {
              fileNames.push(file.name);
            }
          }
        }
      } else {
        // Use DataTransfer interface to access the file(s)
        for (const file of ev.dataTransfer.files) {
          if (file && file.name) {
            fileNames.push(file.name);
          }
        }
      }
    }
    return fileNames;
  }

  dragover(e: DragEvent): void {
    e.preventDefault();
  }

  dragenter(e: DragEvent): void {
    this.startUpload();
    e.preventDefault();
  }

  private startUpload(): void {
    this.percent = 0;
    this.uploadInProgress = true;
    this.increasePercent();
  }

  private increasePercent(): void {
    if (this.percent >= 100) {
      this.uploadInProgress = false;
      return;
    }
    this.percent++;
    this.timerProgress = window.setTimeout(this.increasePercent, 30);
  }

  private abortUpload() {
    if (this.timerProgress) {
      window.clearInterval(this.timerProgress);
      this.timerProgress = null;
    }
    this.uploadInProgress = false;
    this.percent = 0;
    this.error();
  }

  private error() {
    this.shake = true;
    setTimeout(() => {
      this.shake = false;
    }, 1000);
  }
}
</script>
<style scoped>
.dragAndDropArea {
  width: 100%;
  height: 10vh;
  min-height: 120px;
  cursor: pointer;
  background-color: lightslategray;
  margin-bottom: 10px;
}

.centered {
  width: 100%;
  height: 100%;
  display: flex;
  align-items: center;
  justify-content: center;
}

.success {
  animation: blink 1s cubic-bezier(0.55, 0.085, 0.68, 0.53);
}

@keyframes blink {
  0%,
  100% {
    background-color: #76efa0;
  }
}

.shake {
  animation: shake 0.82s cubic-bezier(0.36, 0.07, 0.19, 0.97) both;
  transform: translate3d(0, 0, 0);
}
@keyframes shake {
  10%,
  90% {
    transform: translate3d(-1px, 0, 0);
  }
  20%,
  80% {
    transform: translate3d(2px, 0, 0);
  }
  30%,
  50%,
  70% {
    background-color: tomato;
    transform: translate3d(-4px, 0, 0);
  }
  40%,
  60% {
    transform: translate3d(4px, 0, 0);
  }
}
</style>
